package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFStep;
import com.sa.ibiz.demo.demo.service.WFStepService;
import com.sa.ibiz.demo.demo.service.dto.WFStepSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfstep")
public class WFStepResource
{
	@Autowired
	private WFStepService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<WFStep> remove(@Validated @RequestBody WFStep data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤[remove]操作发生错误","WFStep",data.getWfstepid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFStep> create(@Validated @RequestBody WFStep data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤[create]操作发生错误","WFStep",data.getWfstepid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFStep> checkKey(@Validated @RequestBody WFStep data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤[checkKey]操作发生错误","WFStep",data.getWfstepid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFStep> getDraft(@Validated @RequestBody WFStep data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤[getDraft]操作发生错误","WFStep","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFStep> update(@Validated @RequestBody WFStep data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤[update]操作发生错误","WFStep",data.getWfstepid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFStep> get(@Validated @PathVariable String id){
		WFStep data=new WFStep();
		data.setWfstepid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流步骤[get]操作发生错误","WFStep",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFStep>> searchDefaultPage(@Validated @RequestBody WFStepSearchFilter filter){
		Page<WFStep> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFStep>> listDefault(@Validated @RequestBody WFStepSearchFilter filter){
		List<WFStep> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
